# Advanced Course in Object Oriented Programming

Hello!

Welcome to the course Advanced Course in Object Oriented Programming. The course material is based on the Finnish instance of this course as well as to literature TODO references to the books. However, some differences to the original course materials and exercises will occur. Additionally, please note that the length between different parts varies greatly, so take this into consideration when you are planning out your curriculum!

## How this course differs from previous courses?

 On the previous courses you learned (in addition to programmatic thinking) to solve *a problem* by providing *a solution*. On this course we will go little bit deeper to *designing a solution*, e.g. we aim to identify *why* a solution is a good (or bad), and *how* the solution should be designed. However, this course has emphasis on the object oriented programming related techniques and tools.
 
 When one considers designing a program, there are no right or wrong answers, as the code quality is a complex question to answer. Should you rely on metrics (performance, clarity, amount of code lines), intuition or design principles? This course aims to provide you with tools and techiques that help you on this hard task! The course has two main themes in software engineering: object based design and, in terms of software specification, design by contract.


## Getting started

This course exercises are being hosted on an educational platform called ViLLE. To access the platform, please use the link provided in the course's welcome email. Furthermore, to get access to the course's Discord server, please use the invite link found in the ViLLE, under the *1. START HERE: Welcome to the Course!* -section. 

Please utilize the Discord server to ask any questions you may have regarding the course, exercises, or materials. It's also a great place to seek assistance with any of the exercises.  We also greatly appreciate any feedback you might have regarding the course. You may also reach out to course instructors through the email.

We also offer variety of other courses, full list available [here](https://www.tuas.fi/en/study-tuas/open-studies/about-open-studies/open-programming-and-databases-course/).


**NOTE**: This course have some knowledge prequisites. For more details, look at *1. START HERE: Welcome to the Course!* -section in ViLLE. 

## Practical questions

The course is held fully remote and all the materials will be provided in this repository and in ViLLE. As this is first instance this course is run in English, some changes may occur during the course. Also if you spot any mistakes or hard to understand things in the material, please reach out to us!

Start from the [Part 1 - Introduction](Part%201.1%20-%20Introduction.md). 

